#ifndef GAME_H
#define GAME_H

#include "Level.h"
#include "Camera.h"
#include "Player.h"
#include "StateLoopIFC.h"
#include <iostream>

class Game : public StateLoopIFC
{
    public:
        Game(StateMachine* machine);
        virtual ~Game();

        bool newGame(string file = "level1.level");
        void spawnPlayer();

        virtual void update(int value);
        virtual void display();
        virtual void key(unsigned char key, int x, int y);

        virtual void reshape(int width, int height);
        virtual void assumeControl(StateLoopIFC*& currentActor);

        virtual void specialDown(int key, int x, int y);
        virtual void specialUp(int key, int x, int y);

    protected:
        int offsetX, offsetY;
        Level* level;
        Player* twi;
        Camera* camera;
        irrklang::ISoundSource* winSound;

        Artist* artist;
        WubManager* vinylScratch;

        void updateObject(Object* obj);
        Rect iteratePosition(const Rect& startPoint, Rect resultPoint, bool xAxis, float slope, int sign);

        bool fatalCollision(Rect box);
        bool nonFatalCollision(Rect box);

        void checkLevelFinished();
};

#endif // GAME_H
