#ifndef LEVEL_H
#define LEVEL_H

#include "Decoration.h"
#include "Platform.h"
#include "Trap.h"
#include <vector>
#include <fstream>

using namespace std;

class Level
{
    public:
        Level() { bg = NULL; }
        virtual ~Level() { if(bg) delete bg; bgDecs.clear(); platforms.clear(); fgDecs.clear(); }

        bool loadFile(string filename);
        void displayBg(Rect camera, int xOffset = 0, int yOffset =0);
        void displayFg(Rect camera, int xOffset = 0, int yOffset =0);
        Rect getBgSize() { return bg->getBounds(); }

        void getSize(int& w, int& h) { w = width; h = height; }

        int getWidth() { return width; }
        int getHeight() { return height; }

        int getSpawnX() { return spawnX; }
        int getSpawnY() { return spawnY; }

        const vector<Platform*>* getPlatforms() { return &platforms; }
        const vector<Trap*>* getTraps() { return &traps; }


        const Rect& getWinZone() { return winZone.getBounds(); }

        string getnextLevel(){ return nextLevelName; }


    protected:
        int width, height, spawnX, spawnY;
        Decoration winZone;
        string levelName, nextLevelName;
        Image* bg;
        vector<Decoration*> bgDecs;
        vector<Platform*> platforms;
        vector<Trap*> traps;
        vector<Decoration*> fgDecs;

        void loadDecoration(ifstream& in);
        void loadPlatform(ifstream& in);
        void loadBackground(ifstream& in);
        void loadTrap(ifstream& in);
        void loadProperties(ifstream& in);

};

#endif // LEVEL_H
