#ifndef MENU_H
#define MENU_H

#include "StateLoopIFC.h"
#include "Button.h"
#include <iostream>

class Menu : public StateLoopIFC
{
    public:
        Menu(StateMachine* machine);
        virtual ~Menu();

        void setBg(string file){
            if(bg)
                delete bg;

            bg=new Image(file); }

        virtual void update(int value);
        virtual void mouseMove(int x, int y);
        virtual void mouseButton(int button, int state, int x, int y);
        virtual void display();
        virtual void reshape(int width, int height);
        virtual void assumeControl(StateLoopIFC*& currentActor);

    protected:
        int offsetX, offsetY;
        Image* bg;
        Button* startButton;
        Button* quitButton;

        Artist* artist;
};

#endif // MENU_H
