#ifndef OBJECT_H
#define OBJECT_H

#include "Image.h"

#define DEFAULT_FRICTION 20
#define X_TERMINAL_VELOCITY 400
#define Y_TERMINAL_VELOCITY 600

class Object
{
    public:
        Object();
        Object(string spritefile);
        virtual ~Object();

        void xAcc(int acc) { xVel += acc; }
        void yAcc(int acc) { yVel += acc; }

        virtual void xBump() { xVel = 0; }
        virtual void yBump(int friction = DEFAULT_FRICTION) { yVel = 0; this->friction = friction; }


        void setSprite(string filepath);

        Rect update();
        Rect getPosition(){ return hitbox; }
        Rect getXNudge();
        Rect getYNudge(int nudge = 0);
        int getX() { return hitbox.x; }
        int getY() { return hitbox.y; }
        void setPosition(int x, int y) { hitbox.x = x; hitbox.y = y; }
        void setPosition(Rect pos) { hitbox.x = pos.x; hitbox.y = pos.y; }
        virtual void setX(int x) { hitbox.x = x; }
        virtual void setY(int y) { hitbox.y = y; }
        virtual void display(int xOffset = 0, int yOffset = 0 ){
                    sprite->nextFrame();
                    sprite->display(hitbox.x + xOffset, hitbox.y + yOffset);
                    }

        virtual void setGrounded(bool grounded) { if(!grounded) friction = 0; }

    protected:
        Image* sprite;
        Rect hitbox;
        int xVel, yVel, friction;
};

#endif // OBJECT_H
