#ifndef PONY_H
#define PONY_H

#include "Object.h"
#include "WubManager.h"

class Pony : public Object
{
    public:
        Pony();
        Pony(string spritefile);
        virtual ~Pony();

        void setIntendedXAcc(int acc);

        void ponySetup();

        void act();
        void jump();
        void xBrake();

        void faceRight(bool right);

        virtual void yBump(int friction = DEFAULT_FRICTION) { Object::yBump(friction); }
        virtual void display(int xOffset = 0, int yOffset = 0 );

        virtual void setGrounded(bool grounded);

    protected:
        irrklang::ISoundEngine* dj;
        irrklang::ISoundSource* jumpSound;
        irrklang::ISoundSource* landSound;

        int intendedXAcc;
        bool grounded;
};

#endif // PONY_H
