#include "Decoration.h"

using namespace std;

Decoration::Decoration()
{
    z = 0;
    floating = false;
    floatOffset = 0;
    floatVelocity = 0;
    floatAngle = rand() % 360;
    floatAngle *= TWO_PI / 360;
}

Decoration::~Decoration()
{
    //dtor
}

void Decoration::setFloating(bool f)
{
    floating = f;
    floatAngle = rand() % 360;
    floatAngle *= TWO_PI / 360;
}

void Decoration::display(int xOffset, int yOffset, Rect camera)
{
    if(floating)
        floatAngle += TWO_PI / 360;

    int x = bounds.x;
    int y = bounds.y;

    int camx = camera.x;
    int camy = camera.y;

    if(z>=0)
    {
        y += FLOAT_BOBBING * sin(floatAngle);
        if(z>0)
        {
            x += camx*z/(z+1);
            y += camy*z/(z+1)/4;
        }

    }
    else if(z<0)
    {
        x -= camx*z/(z-1);
        y -= camy*z/(z-1)/4;
    }

    if(x + bounds.w > camx && x < camx + camera.w && y + bounds.h > camy && y < camy+camera.h)
        Image::display(x + xOffset - camx - bounds.x, y + yOffset - camy - bounds.y);
    //cout << "displayed at " << xOffset + bounds.x << " , " << yOffset + floatOffset + bounds.y << "\n";
}
