#include "Trap.h"

Trap::Trap()
{
    xfloating = 0;
    xfloatAngle = rand() % 360;
    xfloatAngle *= TWO_PI / 360;

    yfloating = 0;
    yfloatAngle = rand() % 360;
    yfloatAngle *= TWO_PI / 360;

    startingX = 0;
    startingY = 0;

    dj = WubManager::Instance()->getDJ();
    loopSound = NULL;
}

Trap::~Trap()
{
    //dtor
}

void Trap::setLoopSound(string filename)
{
    if(loopSound)
        loopSound->drop();

    loopSound = WubManager::Instance()->requestSoundSource(filename);

    if(dj)
        dj->play3D(loopSound, vec3df((hitbox.x + hitbox.w/2)/SOUNDSCALE, (hitbox.y + hitbox.h)/SOUNDSCALE, 0), true);
}

void Trap::partition(int p)
{
    if(sprite)
    {
        sprite->partition(p,1);
        sprite->getFrameSize(hitbox.w, hitbox.h);
    }

    cout << "partitioning " << p << "\n";
}

//void Trap::setX(int x)
//{
//    startingX = x;
//    int rnd = rand()%360 * (TWO_PI/360);
//    hitbox.x = startingX + xfloating * cos(rnd);
//    hitbox.y = startingX + xfloating * sin(rnd);
//}
//
//void Trap::setY(int y)
//{
//    startingY = y;
//    int rnd = rand()%360 * (TWO_PI/360);
//    hitbox.x = startingY + yfloating * cos(rnd);
//    hitbox.y = startingY + yfloating * sin(rnd);
//}

void Trap::setXFloating(int f)
{
    xfloating = f;
    xfloatAngle = rand() % 360;
    xfloatAngle *= TWO_PI / 360;

    if(yfloating)
        yfloatAngle = xfloatAngle;
}

void Trap::setYFloating(int f)
{
    yfloating = f;
    yfloatAngle = rand() % 360;
    yfloatAngle *= TWO_PI / 360;

    if(xfloating)
        xfloatAngle = yfloatAngle;
}

void Trap::display(int xOffset, int yOffset)
{
    sprite->nextFrame();

    if(xfloating)
    {
        xfloatAngle += TWO_PI / 360;
        hitbox.x = startingX + xfloating * cos(xfloatAngle);
    }
    if(yfloating)
    {
        yfloatAngle += TWO_PI / 360;
        hitbox.y = startingY + yfloating * sin(yfloatAngle);
    }

    sprite->display(hitbox.x + xOffset, hitbox.y + yOffset);

    //cout << "displayed at " << xOffset + hitbox.x << " , " << yOffset + floatOffset + hitbox.y << "\n";
}
